=== debian/rules ===
#!/usr/bin/make -f

#testsuite needs writable $HOME
FAKEHOME = $(CURDIR)/debian/fakehome

# skip tests requiring network
export GTEST_FILTER = address_from_url.*:dns_resolver.*

%:
	dh $@ --parallel --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- -DARCH=default -DNO_AES=ON -DBUILD_TESTS=ON

override_dh_auto_test:
	HOME="${FAKEHOME}" dh_auto_test -- ARGS+="--output-on-failure -E core_tests"

override_dh_install:
	dh_install

override_dh_missing:
	dh_missing --fail-missing

override_dh_auto_clean:
	rm -rf "$(FAKEHOME)"
	dh_auto_clean
