=== debian/tests/control ===
Tests: monero-tests
Depends: monero-tests
Restrictions: allow-stderr
